/***************************************** (C) COPYRIGHT 2010 Intersil *****************************************
* File Name         : RC.h
* Author            : tang.sc@intersil.com
* Revision          : 1.2.1.1275
* Date              : 2012-03-29
* Description       : 
* Change log        : 
*                   
****************************************************************************************************************
* THE PRESENT SOFTWARE IS DISTRIBUTED IN THE HOPE THAT IT WILL PROVIDE CUSTOMERS 
* WITH CODING INFORMATION TO SPEED UP THEIR PRODUCT DEVELOPMENT, BUT WITHOUT
* ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS
* FOR A PARTICULAR PURPOSE. AS A RESULT, TECHWELL SHALL NOT BE HELD LIABLE FOR ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
****************************************************************************************************************/
#ifndef RC_H
#define RC_H

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

    typedef unsigned char                   boolean;
    typedef struct video_rate_control_type  video_rate_control_type;
    typedef struct h264_encoder_t           h264_encoder_t;

#define X264_FRAME_TYPE_I           (0)
#define X264_FRAME_TYPE_P           (1)
#define X264_FRAME_TYPE_IDR         (3)

    struct video_rate_control_type
    {
        int bits_used_frame;
        int norm_frame_bit_budget;
        int norm_bits_used;     //default
        int bits_for_nontext_est;
        int min_frame_bit_budget;
        int max_frame_bit_budget;
        int prev_norm_frame_bits_used;
        int bits_per_frame;
        int bits_per_rc_window;  //default;
        int total_bit_delta;
        int rho;
        int A;

        unsigned int    nz_count;
        unsigned int    rc_window;
        int prev_qp;
        int prev_bit_budget;

        int ratio ;
        int total_ratio;
        int first_frame_qp; 
        int first_10_max_qp;
        int first_10_min_qp;
        unsigned int    rho_qp_table[52];

        int window2;
        int intraperiod;
        int allratio;
        int statusprama;
        int firstGOP;
        // vbr parameter
        int minQP;
        int offsetQP;   //use diff bitrates
        //wbadd scencechang  ---modify cbr here
        int scencechangeflag;
        //dropping frame
        int framepos;
        int normts;  //֡־
        int min_normts;
        int max_normts;
        unsigned int    fps_true;   //ʵFPSӦԵ֡
        int frameNc;
    };


    /**********************************************************
     *   rc_window,,window2,intraperiod  ߼Ĺϵ
     * rc_window: ĿFPS
     * intraperiod: I֡
     * window2:  ȡPFSI֡Сֵ
     *
     *dropping frame
     *framepos: λùϵʶ//IһP֡ʶ
     *fps_true:ʵʱʵFPS
     ***********************************************************/
    struct h264_encoder_t
    {
        video_rate_control_type rc_info[1];
        int     i_frame_type;
        unsigned int    i_rc_frame_num;
        unsigned int    curr_qp;
        unsigned int    bitrate;
        unsigned int    fps;      //ĿFPS
        unsigned int    channel_id;
        unsigned int    delta_time_stamp;    //timestamp (droppint frame) 
        unsigned int    last_time_stamp, curr_time_stamp; 
    };

    /******************************CBRҪӿں*******************************/
    //RCʼ...
    extern int ISIL_rc_init(h264_encoder_t *encoder, unsigned width , unsigned height , unsigned target_bitrate , unsigned target_fps , unsigned intraPeriod);
    //rcýӿ
    extern void ISIL264_update_rc(h264_encoder_t *encoder);
    //RC
    extern void ISIL264_update_rc_para(h264_encoder_t *encoder , unsigned totalBit , unsigned totalCoeff , unsigned resTotalBit);

    /******************************VBRҪӿں*******************************/
    //RCʼ...    //ͼҪ imgquality
    extern int ISIL_rc_init_ext(h264_encoder_t *encoder, unsigned width , unsigned height , unsigned target_bitrate , unsigned target_fps , unsigned intraPeriod,int imgquality);
    //rcýӿ
    extern void ISIL264_update_rc_ext(h264_encoder_t *encoder);
    //RC
    extern void  ISIL264_update_rc_para_ext(h264_encoder_t *encoder , unsigned totalBit , unsigned totalCoeff , unsigned resTotalBit);


#ifdef __cplusplus
}
#endif // __cplusplus

#endif

