/***************************************** (C) COPYRIGHT 2010 Intersil *****************************************
* File Name         : isil_tasklet.h
* Author            : tang.sc@intersil.com
* Revision          : 1.2.1.1275
* Date              : 2012-03-29
* Description       : 
* Change log        : 
*                   
****************************************************************************************************************
* THE PRESENT SOFTWARE IS DISTRIBUTED IN THE HOPE THAT IT WILL PROVIDE CUSTOMERS 
* WITH CODING INFORMATION TO SPEED UP THEIR PRODUCT DEVELOPMENT, BUT WITHOUT
* ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS
* FOR A PARTICULAR PURPOSE. AS A RESULT, TECHWELL SHALL NOT BE HELD LIABLE FOR ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
****************************************************************************************************************/
#ifndef _ISIL_TASKLET_H
#define _ISIL_TASKLET_H

#ifdef __cplusplus
extern "C"
{
#endif

typedef void    (*isil_tasklet_hook)(unsigned long data);

struct isil_tasklet_operation{
    void    (*init)(isil_tasklet_entry_t *, isil_tasklet_hook callfn, unsigned long data);
    void    (*close)(isil_tasklet_entry_t *);
    void    (*enable)(isil_tasklet_entry_t *);
    void    (*disable)(isil_tasklet_entry_t *);
    void    (*schedule)(isil_tasklet_entry_t *);
};

struct isil_tasklet_entry{
    struct tasklet_struct   task;

    struct isil_tasklet_operation   *op;
};

extern void    init_isil_h264_encode_tasklet(isil_tasklet_entry_t *isil_tasklet_entry, unsigned long data);
extern void    close_isil_h264_encode_tasklet(isil_tasklet_entry_t *isil_tasklet_entry);
extern void    init_isil_audio_encode_tasklet(isil_tasklet_entry_t *isil_tasklet_entry, unsigned long data);
extern void    close_isil_audio_encode_tasklet(isil_tasklet_entry_t *isil_tasklet_entry);

#ifdef __cplusplus
}
#endif

#endif
